#!/usr/bin/env python
# -*- coding: utf-8 -*-

# Poincaré photographic tiling of the poincaré disk  http://poincare.sourceforge.net/
# Notepad2 - free and open source Copyright © 2004-2011 Florian Balmer: http://www.flos-freeware.ch/notepad2.html
# Example: http://gimpchat.com/viewtopic.php?f=22&t=1825&start=0
# Download plugin: http://gimpchat.com/viewtopic.php?f=9&t=11886
# ------------
#| Change Log |
# ------------
# Rel 1: Initial release 2011
# Rel 2: Combined into one plugin, eliminated *.bat files

from gimpfu import *
import shlex
import subprocess
import os, sys
from shutil import copyfile
import stat
import subprocess as sub

pluginDir=os.path.join(gimp.directory,'plug-ins')
pce = pluginDir + os.sep + 'poincare'
		
def replacewith(s, oldvalues, newvalues):
  new_s = s
  for i in range(0,len(oldvalues)):
    new_s = new_s.replace(oldvalues[i],newvalues[i])
  return new_s
  
def plugin_main_poincare(img, layer, copy_img):

  gimp.pdb.file_jpeg_save(img, layer, pce + os.sep + "image_orig" + ".jpg", "raw_filename", 0.9, 0, 0, 0, "Creating with GIMP", 0, 0, 0, 0, run_mode=RUN_NONINTERACTIVE)

  program = pce + os.sep + 'Notepad2.exe'
  mask = pce + os.sep + 'mask.txt'
  p = sub.Popen([program, mask], stdin=sub.PIPE, stdout=sub.PIPE, stderr=sub.STDOUT)
  child_output, child_error = p.communicate(input="234")
  print child_output
  
  program1 = pce + os.sep + 'poincare.exe'
  p = sub.Popen([program1, mask], stdin=sub.PIPE, stdout=sub.PIPE, stderr=sub.STDOUT)
  child_output, child_error = p.communicate(input="234")
  print child_output  
  
 # if copy_mask:
  filefullpath = pce + os.sep + 'mask.txt'
  backup_filefullpath = pce + os.sep + 'render.txt'
  copyfile(filefullpath,backup_filefullpath) #back it up.	
  f = open(backup_filefullpath,"r")
  lines = f.readlines()
  f.close()

  old1 = ['action=mask']
  new1 = ['action=render']
  old2 = ['image_mask.jpg']
  new2 = ['image_poincare.jpg']
  if backup_filefullpath.endswith(".txt"): #.scm file
    f = open(backup_filefullpath,"w")
    for line in lines:
      line = replacewith(line, old1 ,new1)
      line = replacewith(line, old2 ,new2)
      f.write(line)
    f.close()
		
  new_image = pdb.gimp_image_new(img.width, img.height, 0)
  display = pdb.gimp_display_new(new_image)
  im = pce + os.sep + 'image_mask.jpg'
  x = pdb.gimp_file_load_layer(new_image, im)
  pdb.gimp_layer_add_alpha(x)  
  pdb.gimp_image_insert_layer(new_image, x, None, 0)
  
  if copy_img == 1:

    io = pce + os.sep + 'image_orig.jpg'
    x = pdb.gimp_file_load_layer(new_image, io)
    pdb.gimp_image_insert_layer(new_image, x, None, 0)	
    pdb.gimp_image_lower_item_to_bottom(new_image, x)
    new_image.filename=os.path.join(pce,'image_orig.jpg')
	
  program = pce + os.sep + 'poincare.exe'
  render = pce + os.sep + 'render.txt'
  p = sub.Popen([program, render], stdin=sub.PIPE, stdout=sub.PIPE, stderr=sub.STDOUT)
  child_output, child_error = p.communicate(input="234")
  print child_output
  
  file = pce + os.sep + 'image_poincare.jpg'
  gimp.progress_init("Opening '" + file + "'...")
  newImage = pdb.file_jpeg_load(file, file, run_mode=RUN_NONINTERACTIVE)
  pdb.gimp_display_new(newImage)  
  return
  
register(
	"python_fu_poincare",
	"Generating poincare image is a multistep process.\nFirst, you have to identify the “fundamental region”\nfrom an image which you want to base the output on. \
	\nThe fundamental region is a triangular-shaped region (actually, it’s a hyperbolic triangle). \
	\nThis is an iterative process that not particularly intuitive.\nYou have to determine four key points (px, py, rx, and ry)\nin the parameter file. \
	\nEach time you set those parmeters you will generate an output file which shows the masked input image. \
	\nYou will find that you will have to keep tweaking those parameters, until you get the mask just right. \
	\nI often do a dozen or more iterations before I get this step right. \
	\n\nThis plug-in:\n\nwill save active layer as image_orig.jpg and open\n(in notepad) parameters for edit, will create a mask\n(generate just the fundamental region)as image_mask.jpg, will save render.txt and generate image_poincare.jpg",
	"Poincare 0.2",
	"MareroQ",
	"GPL",
	"2019",
	"<Image>/Filters/Render/Poincare disc...",
	"*", 
	[
	(PF_BOOL, "copy_img", "Add original image to layer mask", False),
	],   
	[],
	plugin_main_poincare,
	)

main()
